# Copyright 2014 Baidu, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
# an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
# specific language governing permissions and limitations under the License.
"""
Samples for bos client.
"""

import os
import random
import string

import media_sample_conf
from baidubce.services.bos.bos_client import BosClient
from baidubce.services.media.media_client import MediaClient


def _create_file(file_name, size):
    """Create a file with the file size is size"""
    file = open(file_name, "w")
    file.seek(size)
    file.write('\x00')
    file.close()


def _random_string(length):
    return ''.join(random.choice(string.ascii_lowercase + string.digits) for _ in range(length))


if __name__ == "__main__":
    import logging

    logging.basicConfig(level=logging.DEBUG)
    __logger = logging.getLogger(__name__)

    pipelineName = 'pipelineli68dq'
    presetName = 'bce.video_mp4_1920x1080_3660kbps'
    source_bucket = 'test-yu'
    target_bucket = 'test-yu'
    source_key = '1280_720.mp4'
    target_key = 'targetkey' + _random_string(6)

    ######################################################################################################
    #            bucket operation samples
    ######################################################################################################

    # create a media client
    media_client = MediaClient(media_sample_conf.config)

    # create a pipeline
    # media_client.create_pipeline(pipelineName, source_bucket, target_bucket)

    # create a preset
    extraCfg = {'transMode': 'cae'}
    video = {
                "codec": "h264",
                "codecOptions": {
                    "profile": "high"
                },
                "bitRateInBps": 6000000,
                "maxWidthInPixel": 1280,
                "maxHeightInPixel": 720,
                "sizingPolicy": "keep",
            }
    media_client.create_preset("test12345", 'mp4', video=video, extraCfg=extraCfg)

    # create a job
    # source = {"clips": [{"bucket": source_bucket,
    #                      "sourceKey": source_key}]}
    # target = {"targetKey": target_key,
    #           "presetName": presetName}
    # media_client.create_job(pipelineName, source, target)
    #
    # source = {"sourceKey": source_key}
    # media_client.create_job(pipelineName, source, target)



